library byte_flutter_library;

import 'dart:convert';
import 'package:http/http.dart' as http;

class HKByteNetworkLibrary {
  http.Client client;
  String _baseUrl = '';

  // Creating HTTP Client
  _createClient() {
    client = new http.Client();
  }

  // Initializations
  HKByteNetworkLibrary({baseUrl}) : assert(baseUrl != null && baseUrl != '') {
    _createClient();
    _baseUrl = baseUrl;
  }

  // Sending HTTP [POST Request] to any url
  Future<dynamic> request(String endpoint,
      {Map<dynamic, dynamic> payload = const {},
      bool private = false,
      String token}) async {
    var jsonData;
    final headers = {'Content-Type': 'application/json'};
    final finalUrl = _baseUrl + (private ? '/private/' : '/public/') + endpoint;
    var requestData = {};

    if (token != null) {
      requestData['payload'] = payload;
      requestData['token'] = token;
    }

    try {
      // Sending Request
      var response = await client.post(
        finalUrl,
        body: json.encode(requestData),
        headers: headers,
      );

      // Convert Response to JSON
      jsonData = json.decode(response.body.toString());
      if (response.statusCode >= 400 && response.statusCode < 500) {
        throw response.body;
      } else if (response.statusCode >= 500) {
        throw "Internal Server Error";
      }
    } catch (ex) {
      // Handeling Exception
      print("Error: " + ex.toString());
    } finally {
      client.close();
    }

    return jsonData;
  }
}
